package ru.dbotthepony.mc.otm.menu.matter

import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.core.immutableList
import ru.dbotthepony.mc.otm.block.entity.matter.MatterCapacitorBankBlockEntity
import ru.dbotthepony.mc.otm.block.entity.tech.BatteryBankBlockEntity
import ru.dbotthepony.mc.otm.container.slotted.SlottedContainer
import ru.dbotthepony.mc.otm.menu.MatterContainerInputMenuSlot
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.menu.input.ItemConfigPlayerInput
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.ProfiledLevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.game.MMenus

class MatterCapacitorBankMenu(
	p_38852_: Int,
	inventory: Inventory,
	tile: MatterCapacitorBankBlockEntity? = null
) : MatteryMenu(MMenus.MATTER_CAPACITOR_BANK, p_38852_, inventory, tile) {
	val matterGauge = ProfiledLevelGaugeWidget(this, tile?.profiled)
	val totalMatterGauge = LevelGaugeWidget(this)
	val itemConfig = ItemConfigPlayerInput(this, tile?.itemConfig)

	val storageSlots: List<MatterContainerInputMenuSlot>

	init {
		if (tile != null) {
			totalMatterGauge.with({
				tile.matterNode.graph.getMatterStorageLevel()
			}, {
				tile.matterNode.graph.getMatterStorageMaxLevel()
			})
		}

		val container = tile?.container ?: SlottedContainer.simple(BatteryBankBlockEntity.CAPACITY)

		storageSlots = immutableList(BatteryBankBlockEntity.CAPACITY) {
			addStorageSlot(MatterContainerInputMenuSlot(container, it))
		}

		addInventorySlots()
	}
}
